Bug 3796 - Enabling extras-devel repository breaks application installer due to an error in the Packages file
: Enabling extras-devel repository breaks application installer due to an error...
Status: RESOLVED INVALID
Product: maemo.org Website
Repositories
: 4.1
: All Linux
: High normal (vote)
: ---
Assigned To: Marcell Lengyel
: repositories@maemo.bugs
:
: moreinfo
:
:
  Show dependency tree
 
Reported: 2008-10-10 09:37 UTC by Marius Gedminas
Modified: 2009-05-31 12:08 UTC (History)
3 users (show)

See Also:


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description Marius Gedminas (reporter) 2008-10-10 09:37:24 UTC
SOFTWARE VERSION:
(Control Panel > General > About product)

4.2008.36-5

STEPS TO REPRODUCE THE PROBLEM:

Start Application Installer
Enable the extras-devel repository
Refresh package list

EXPECTED OUTCOME:

Apps show up

ACTUAL OUTCOME:

There's a popup saying "Operation failed" and the list of available apps is
empty.  The log says

E: Problem parsing dependency Depends
E: Error occurred while processing easy-deb-chroot (NewVersion1)
E: Problem with MergeList
/var/lib/apt/lists/repository.maemo.org_extras-devel_dists_diablo_non-free_binary-armel_Packages
E: The package lists or status file could not be parsed or opened.

The line that causes the problem is 'Depends: \n'.  Removing it with vi as root
and fixes the application installer.

REPRODUCIBILITY:
always

EXTRA SOFTWARE INSTALLED:

OTHER COMMENTS:

The scripts that generate Packages files on the repository should be updated so
they never produce an empty 'Depends:' line.  Filtering those through

  grep -v
"^\(Depends\|Suggests\|Pre-Depends\|Recommends\|Conflicts\|Replaces\): *$"

ought to suffice.

I've experienced this problem when I was maintaining my own repository. 
Apparently some versions of dpkg-scanpackages like to produce these empty lines
when the debian/control file for the package in question has no
dependencies/etc., but those lines break the version of apt that is used in
Maemo.
Comment 1 Marius Gedminas (reporter) 2008-10-10 20:30:20 UTC
FWIW this also completely breaks the extras autobuilder.
Comment 2 Ryan Abel maemo.org 2008-10-10 21:05:34 UTC
Niels seems to have fixed it.
Comment 3 Niels Breet maemo.org 2008-10-10 22:18:57 UTC
I didn't do that ;) So if it is fixed, something else must have happened. 

Can anyone verify?
Comment 4 Daniel Martin Yerga 2008-10-10 22:37:41 UTC
(In reply to comment #3)
> I didn't do that ;) So if it is fixed, something else must have happened. 
> 
> Can anyone verify?
> 

I can confirm that the packages list is correctly refreshed in the application
manager/apt. But the bug could be valid yet (changing the title), how I am not
seeing the easy-deb-chroot package (that seems be the one with the Depends:\n
line) in the Packages file in the repository.
Comment 5 Marius Gedminas (reporter) 2008-10-10 22:59:02 UTC
I guess the question now is: will the next package that's uploaded without a
Depends: field in debian/control break the extras-devel repository again, or
not?
Comment 6 Marcell Lengyel maemo.org 2008-12-05 12:03:41 UTC
I have been checking this and the finger of blame points to apt-ftparchive.
That's the one that generates the Packages file. There is no easy way to check
in advance if a package will break something after apt-ftparchive processes it
or not. One possible solution is to filter the Packages file after each new
pacakge is added and check for defects.
However I would rather report the bug upstream and get the problem fixed in
apt-ftparchive. Now if somebody could attach the .deb package that was causing
all this trouble...
Comment 7 Andre Klapper maemo.org 2009-01-15 14:26:50 UTC
> However I would rather report the bug upstream and get the problem fixed in
> apt-ftparchive. 

...which is part of apt-utils and handled in https://bugs.debian.org .
See http://bugs.debian.org/cgi-bin/pkgreport.cgi?package=apt-utils for existing
bug reports.

(In reply to comment #6)
> Now if somebody could attach the .deb package that was causing
> all this trouble...

Can somebody please do this so we have some progress here? According to comment
4 this might have been easy-deb-chroot.
Comment 8 Andre Klapper maemo.org 2009-05-20 16:43:30 UTC
...still waiting for the offending package here.
Comment 9 Andre Klapper maemo.org 2009-05-31 12:08:19 UTC
> (In reply to comment #6)
> > Now if somebody could attach the .deb package that was causing
> > all this trouble...

Closing this bug report as no further information has been provided. Please
feel free to reopen this bug if you can provide the information asked for/if
you can still reproduce this. Thanks!